Feedback Management APIs


The Feedback Management APIs provide near real-time access to survey data collected in CXone. They enable administrators and developers to search, retrieve, and export survey responses, invitation records, and survey metadata for integration with internal CXone components and external systems such as reporting, analytics, and business intelligence tools.

The Feedback Management APIs are available for CXone customers with Feedback Management (survey) capabilities enabled.

API Authentication

To use any Feedback Management API, first, you need to authenticate users.

Note: If you implemented a Feedback Management API before February 2022 you can see the appendix for more information on the Basic Authentication Method.

Bearer Token User Authentication Method

Use the bearer token-based authentication method to authenticate users for the Feedback Management APIs. This method uses the OAuth2.0 method for advanced security.

To authenticate APIs using this method, you need to include an access token within the Authorization header of each request while making an API call. To obtain the access token, follow the steps provided below in the Generating your access token section.

It is mandatory to pass a bearer access token generated using the user-level API key. Note: The bearer access token generated using the old enterprise-level token will not work.

Generating Your Access Token

To generate your access token, you need to perform the following steps:

  • Get your API key
  • Create access keys using your API key
  • Generate your access token using your access key and access secret key
NOTE: The access token that you generate is valid only for 60 mins. After 60 mins, you must regenerate the token.

Step 1. Get API Key

First, you must register your enterprise with NICE. Then, obtain the API key at the user level. See the API Key section of your user profile to get your API key.

Step 2. Create Access Keys

To obtain your access key ID and access secret key, you must send your API key and your enterprise identifier to NICE Feedback Management in your HTTPS request header.

POST - https://<NPX_HOST>/npxapi/authentication/v1.0/access-keys

For example:

POST - https://acme.satmetrix.com/npxapi/authentication/v1.0/access-keys

Pass the following header parameters to retrieve your access token:

Header Parameter Description
token The API key you generated in step 1.
tenantId Your enterprise identifier. You can get the enterprise identifier from the Admin > Advanced Admin > System Settings > Company tab > Enterprise ID field.

Sample Response Body

{
  "accessKey": {
    "accessKeyId": "xxxxxxxxxxxxxxxxxxxxxxxxx",
    "accessKeySecret": "xxxxxxxxxxxxxxxxxxxxxxxx"
  }
}

Step 3. Generate Access Token

Once you have your access keys obtained from step 2, send an HTTPS request to our token service, including the access keys and your enterprise identifier, to receive your access token.

POST - https://<NPX_HOST>/npxapi/authentication/v1.0/token

For example:

POST - https://acme.satmetrix.com/npxapi/authentication/v1.0/token

Pass the following header parameters to retrieve your access keys:

Header Parameter Description
accessKeyId The access key ID you generated in step 2.
accessKeySecret The access key secret you generated in step 2.
tenantId Your enterprise identifier. You can get the enterprise identifier from the Admin > Advanced Admin > System Settings > Company tab > Enterprise ID field.

Sample Response Body

{
  "accessToken": "xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx",
  "expiresIn": 3600,
  "tokenType": "bearer"
}
Loading...